// TSMorph - Amiga Morphing program
// Copyright (C)  1993  Topicsave Limited

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// mpaddock@cix.compulink.co.uk

// Defines for all external messages
#define MSG_ABOUT		0
#define MSG_OK			1
#define MSG__OK		2
#define MSG_FAILURE	3
#define MSG_OTSMW		4
#define MSG_SUSCR		5
#define MSG_UNABLE	6
#define MSG_FILER		7
#define MSG_CWMP		8
#define MSG_CANNOTOP	9
#define MSG_QUIT		10
#define MSG_PICKIFF	11
#define MSG_IMSMALL	12
#define MSG_IMDIFF	13
#define MSG_UNALLOC	14
#define MSG_ZOOMR		15
#define MSG_SETMENU	16
#define MSG_OPENW		17
#define MSG_ALLOCFIL	18
#define MSG_DOWNG		19
#define MSG_UPG		20
#define MSG_RIGHTG	21
#define MSG_LEFTG		22
#define MSG_UPI		23
#define MSG_DOWNI		24
#define MSG_RIGHTI	25
#define MSG_LEFTI		26
#define MSG_VGAD		27
#define MSG_HGAD		28
#define MSG_ALLOCILB	29
#define MSG_GETSDI	30
#define MSG_LOCKPUBS	31
#define MSG_LOADPO	32
#define MSG_LOADPR	33
#define MSG_VERS10	34
#define MSG_INVLINE	35
#define MSG_ITOOSM	36
#define MSG_POOR		37
#define MSG_OOMPO		38
#define MSG_INVPOLI	39
#define MSG_ECLOF		40
#define MSG_EOPF		41
#define MSG_SAVEP		42
#define MSG_EWRR		43
#define MSG_1			44
#define MSG_2			45
#define MSG_REL		46
#define MSG_ADD		47
#define MSG_DEL		48
#define MSG_L1			49
#define MSG_U1			50
#define MSG_MOV		51
#define MSG_4POINTS	52
#define MSG_L2			53
#define MSG_U2			54
#define MSG_NOTLINK	55
#define MSG_LINKSE	56
#define MSG_READYLI	57
#define MSG_UNLSE		58
#define MSG_MEMPO		59
#define MSG_READY		60
#define MSG_TSMERR	61
#define MSG_HELPOR	62
#define MSG__HELPOR	63
#define MSG_DELETEP	64
#define MSG_BISIZE	65
#define MSG_GET241	66
#define MSG_GET242	67
#define MSG_PIC1		68
#define MSG_PIC2		69
#define MSG_MFILEN	70
#define MSG_OPGRIDR	71
#define MSG_BOTHGT0	72
#define MSG_OUTMP		73
#define MSG_UNSAVED	74
#define MSG__SHAC		75
#define MSG__SAC		76
#define MSG_SHAC		77
#define MSG_SAC		78
#define MSG_EAREXX	79
#define MSG_EOPSCR	80
#define MSG_UNDRI		81
#define MSG_LOCKWB	82
#define MSG_INVMODE	83
#define MSG_REMAPH6	84
#define MSG_REMAPH8	85
#define MSG_REMAPEHB	86
#define MSG_REMAPIL	87
#define MSG_NM_PROJECT			88
#define MSG_NM_NEWPOINTS		89
#define MSG_NM_NEWPOINTS_S		90
#define MSG_NM_OPENPOINTS		91
#define MSG_NM_OPENPOINTS_S	92
#define MSG_NM_SAVE				93
#define MSG_NM_SAVE_S			94
#define MSG_NM_SAVEAS			95
#define MSG_NM_SAVEAS_S			96
#define MSG_NM_ABOUT				97
#define MSG_NM_EXITPOINTS		98
#define MSG_NM_QUIT				99
#define MSG_NM_QUIT_S			100
#define MSG_NM_PPREVIEW			101
#define MSG_NM_EDIT				102
#define MSG_NM_ADDGRID			103
#define MSG_NM_ADDGRID_S		104
#define MSG_NM_FRAME				105
#define MSG_NM_FIRST				106
#define MSG_NM_FIRST_S			107
#define MSG_NM_PREVIOUS			108
#define MSG_NM_PREVIOUS_S		109
#define MSG_NM_GOTO				110
#define MSG_NM_GOTO_S			111
#define MSG_NM_NEXT				112
#define MSG_NM_NEXT_S			113
#define MSG_NM_LAST				114
#define MSG_NM_LAST_S			115
#define MSG_NM_EMODE				116
#define MSG_NM_M_ONE				117
#define MSG_NM_M_ONE_S			118
#define MSG_NM_M_TWO				119
#define MSG_NM_M_TWO_S			120
#define MSG_NM_M_REL				121
#define MSG_NM_M_REL_S			122
#define MSG_NM_M_ADD				123
#define MSG_NM_M_ADD_S			124
#define MSG_NM_M_DEL				125
#define MSG_NM_M_DEL_S			126
#define MSG_NM_M_LNK				127
#define MSG_NM_M_LNK_S			128
#define MSG_NM_M_UNL				129
#define MSG_NM_M_UNL_S			130
#define MSG_NM_M_MOV				131
#define MSG_NM_M_MOV_S			132
#define MSG_NM_SETTINGS			133
#define MSG_NM_CREATEICONS		134
#define MSG_NM_CHANGEPALETTE	135
#define MSG_NM_CHANGEPALETTE_S	136
#define MSG_NM_ZOOM				137
#define MSG_NM_ZOOM_S			138
#define MSG_NM_OPENMODE			139
#define MSG_NM_ILBMALWAYS		140
#define MSG_NM_ILBMIFILBM		141
#define MSG_NM_ILBMIFCOLOURS	142
#define MSG_NM_REMAP				143
#define MSG_NM_ILBMOPAL			144
#define MSG_NM_SCREEN			145
#define MSG_NM_CUSTOM			146
#define MSG_NM_CDEPTH			147
#define MSG_NM_SPREVIEW			148
#define MSG_NM_ICONSP			149
#define MSG_NM_KEEPS				150
#define MSG_NM_LOADS				151
#define MSG_NM_SAVES				152
#define MSG_NM_SAVESAS			153
#define MSG_NM_ICONSR			154
#define MSG_NM_DX					155
#define MSG_NM_DY					156
#define MSG_NM_LOADSCRIPT		157
#define MSG_NM_PRESCRIPT		158
#define MSG_NM_POSTSCRIPT		159
#define MSG_NM_DEPTH				160
#define MSG_NM_MODE				161
#define MSG_NM_MODE1				162
#define MSG_NM_MODE2				163
#define MSG_NM_MODE4				164
#define MSG_NM_MODE8				165
#define MSG_NM_XX1				166
#define MSG_NM_XX2				167
#define MSG_NM_XX3				168
#define MSG_NM_XX4				169
#define MSG_NM_SAVEFORMAT		170
#define MSG_NM_ILBM24			171
#define MSG_NM_OPAL24			172
#define MSG_NM_OPAL24T			173
#define MSG_NM_OPAL24F			174
#define MSG_NM_OPAL24FT			175
#define MSG_NM_OPALJPEG			176
#define MSG_NM_OPALJPEGT		177
#define MSG_NM_PBM				178
#define MSG_NM_BW16				179
#define MSG_NM_BW256				180
#define MSG_NM_HAM6				181
#define MSG_NM_HAM8				182
#define MSG_NM_DCTV3				183
#define MSG_NM_DCTV4				184
#define MSG_NM_QUALITY			185
#define MSG_NM_SCREENR			186
#define MSG_NM_ANTIALIAS		187
#define MSG_NM_INTEGER			188
#define MSG_NM_RESETD			189
#define MSG_NM_LASTS				190
#define MSG_NM_RESTORE			191
#define MSG_NM_HELP				192
#define MSG_NMT_NEW				193
#define MSG_NMT_OPEN				194
#define MSG_NMT_DELETE			195
#define MSG_NMT_EDITPOINTS		196
#define MSG_NMT_EDITPOINTS_S	197
#define MSG_TSMFRAME				198
#define MSG_TSM					199
#define MSG_FRAMENO				200
#define MSG_OKHC					201
#define MSG_OKC					202
#define MSG_MUST1F				203
#define MSG_FRAMESIZE			204
#define MSG_FAILLOAD				205
#define MSG_NM_MODE16			206
#define MSG_NM_TRIANGULATE		207
#define MSG_NM_TRIANGULATE_S	208

#define MSG_COUNT		209		// Last message number + 1
